<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width">
<title>HFS %folder%</title>
<meta charset=UTF-8 />
<style>
body {background: #eef}
th {background: #47c}
tr {background: #fff}
a {text-decoration: none}
a[href*=login] {float: right}
button {cursor: pointer; background:transparent;border:none}
tr:hover td {background: #EEE} 
td div[title] {opacity:.54; font-size:14px; display:inline-block} 
td div:nth-child(2) {width:200px} 
td div:nth-child(3) {width:100px}
td:first-child {width:72px}
td:nth-child(3) {width:72px;text-align:center}
</style>
</head>
<body>
{.$list.}
<script>
function handleFiles(filesArray) {
var xhr = new XMLHttpRequest();
var fd = new FormData();
var progressBar = document.querySelector('progress'); progressBar.style.display=''
xhr.open("POST", "%folder%");
for (var i=0; i<filesArray.length; i++) fd.append('myFile', filesArray[i], filesArray[i].name)
xhr.upload.onprogress = function(e) {if (e.lengthComputable) progressBar.value = e.loaded / e.total}
xhr.onload = function() {if(xhr.responseText) document.write(xhr.responseText); else location.reload()}
xhr.send(fd)
}

function del(){
var it=document.querySelectorAll('.selector:checked'), qstr=''
if(!it.length || !confirm("Delete "+it.length+" file(s) ?")) return 0;
it.forEach(function(userItem) {qstr+='&selection='+userItem.value})
var xhr = new XMLHttpRequest();
xhr.open("POST", "%folder%")
xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded")
xhr.onload = function() {document.write(xhr.responseText)}
xhr.send("action=delete"+qstr)
}

function search(){location.href="%folder%?search="+(prompt("search")||'')}

function newfold(){
var tmp=prompt("new folder")
if(tmp) location.href="/~mypage?id=%folder%"+tmp
}
</script>

</body>
</html>

[mypage]
{.mkdir|{.?id.}.}
{.redirect|{.?id.}.}

[unauthorized]
<h1>{.!Unauthorized.}</h1>
{.!Either your user name and password do not match, or you are not permitted to access this resource..}

[file=folder]
{.set|mask|{:{.match|jpg;png;gif|%item-ext%.}:}.}
<tr id="%item-url%" {.if|{.^mask.}|class="media".}><td>
<img src= {.if|{.^mask.}|"thumb/%item-url%" style="width:64px;height:64px;object-fit:cover" onclick='show|"%item-icon%" onclick='location=.}("%item-url%")' alt="&#x1f304;" title="%item-name%" /></td>

[+file=+folder]
<td>
<div><a href="%item-url%" style="color:black; font-size:16px">%item-name%</a></div>
<div title="%item-comment%">%item-modified% {.if|{.get|is new.}|&#x1F195;.}</div>
<div title="%item-dl-count%">{.or|%item-size%|.}</div>
</td>
<td>
<input type="checkbox" class='selector' name='selection' value="%item-url%" {.if not|{.or|{.get|can delete.}|{.get|can access.}|{.get|can archive item.}.}|disabled='disabled'.} ></td>
</tr>

[list]
<div id='files_outer'>
	<div style='height:1.6em;'></div>

        <div>  <!-- form method='post'  -->
{.breadcrumbs|{:<a href ="%bread-url%">%bread-name%/</a>:}.} <a href="/~login">&#x1f464; %user%</a>
<input type="file" id="fileElem" multiple style="display:none" onchange="handleFiles(this.files)" onclick="this.style.display=''">
<table id='files' style="width:100%; border-spacing:0px 1px; font-family:Helvetica">
<tr>
<th><button onclick="search()" title="HFS %version%">&#x2315;</button>
<th><progress style="display:none"></progress> <select onchange='location=this.value'>
<option {.if|{.=|{.urlvar|sort.}|n.}|selected.} value="{.get|url|sort=n|rev={.?sort=n.}.}">Name</option>
<option {.if|{.=|{.urlvar|sort.}|s.}|selected.} value="{.get|url|sort=s|rev={.?sort=s.}.}">Size</option>
<option {.if|{.=|{.urlvar|sort.}|t.}|selected.} value="{.get|url|sort=t|rev={.?sort=t.}.}">Timestamp</option>
<option value="{.get|url|rev={.not|{.?rev.}.}.}">order &{.if|{.?rev.}|u|d.}arr;</option>
</select>&nbsp;
<button onclick="document.querySelector('dialog').showModal()">&#x2261;</button>
<dialog>{.if|{.get|can upload.}|<button onclick="fileElem.click()">&#x21e7;</button>.}{.if|{.get|can upload.}|<button onclick="newfold()">&#x1f5c0;<sup>+</sup></button>.}{.if|{.get|can delete.}|<button onclick="del()">X</button>.} <button onclick="document.querySelector('dialog').close()"><sup>&times;</sup></button></dialog>
<th>
</tr>
%list%
</table>
        </div>

</div>

[not found]
<h1>{.!Not found.}</h1>
<a href="/">{.!go to root.}</a>